<html><head><meta name="color-scheme" content="light dark"></head><body><pre style="word-wrap: break-word; white-space: pre-wrap;">From 268194c8c3e172da60212713cae7a5f7fe243220 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Bj=C3=B6rn=20Pedersen?= &lt;bjoern.pedersen@frm2.tum.de&gt;
Date: Wed, 13 Feb 2013 17:31:43 +0100
Subject: [PATCH] [JENKINS-14955] Fix wrong root URL with --prefix

If jenkins is run with --prefix then the rootURL has to be adjusted.
---
 .../com/tikal/jenkins/plugins/multijob/MultiJobBuild/main.jelly       | 4 ++--
 .../com/tikal/jenkins/plugins/multijob/MultiJobProject/main.jelly     | 4 ++--
 .../tikal/jenkins/plugins/multijob/views/ConsoleColumn/column.jelly   | 2 +-
 .../com/tikal/jenkins/plugins/multijob/views/JobColumn/column.jelly   | 4 ++--
 .../tikal/jenkins/plugins/multijob/views/WeatherColumn/column.jelly   | 4 ++--
 5 files changed, 9 insertions(+), 9 deletions(-)

diff --git a/src/main/resources/com/tikal/jenkins/plugins/multijob/MultiJobBuild/main.jelly b/src/main/resources/com/tikal/jenkins/plugins/multijob/MultiJobBuild/main.jelly
index d347b07..d42fda0 100644
--- a/src/main/resources/com/tikal/jenkins/plugins/multijob/MultiJobBuild/main.jelly
+++ b/src/main/resources/com/tikal/jenkins/plugins/multijob/MultiJobBuild/main.jelly
@@ -17,7 +17,7 @@
 	 			&lt;td class="no-wrap"&gt;
 	 				&lt;j:choose&gt;
 		 				&lt;j:when test="${builder.url.length() &gt; 0}"&gt;
-			 				&lt;a href="/${builder.url}"&gt;
+			 				&lt;a href="${rootURL}/${builder.url}"&gt;
 		                		build #${builder.buildNumber}
 		              		&lt;/a&gt;
 	              		&lt;/j:when&gt;
@@ -31,4 +31,4 @@
 
 	&lt;p:upstream-downstream /&gt;
 
-&lt;/j:jelly&gt;
\ No newline at end of file
+&lt;/j:jelly&gt;
diff --git a/src/main/resources/com/tikal/jenkins/plugins/multijob/MultiJobProject/main.jelly b/src/main/resources/com/tikal/jenkins/plugins/multijob/MultiJobProject/main.jelly
index feba30d..4e06667 100644
--- a/src/main/resources/com/tikal/jenkins/plugins/multijob/MultiJobProject/main.jelly
+++ b/src/main/resources/com/tikal/jenkins/plugins/multijob/MultiJobProject/main.jelly
@@ -6,7 +6,7 @@
 		&lt;j:when test="${it.topMost}"--&gt;
 			&lt;br /&gt;
 			&lt;t:projectView jobs="${it.view.getRootItem(it)}"
-				jobBaseUrl="${it.rootUrl}" showViewTabs="false" columnExtensions="${it.view.columns}"&gt;
+				jobBaseUrl="${rootURL}/" showViewTabs="false" columnExtensions="${it.view.columns}"&gt;
 			&lt;/t:projectView&gt;
 		&lt;!--/j:when&gt;
 	&lt;/j:choose--&gt;
@@ -49,4 +49,4 @@
 	&lt;/j:forEach&gt;
 
 	&lt;p:upstream-downstream /&gt;
-&lt;/j:jelly&gt;
\ No newline at end of file
+&lt;/j:jelly&gt;
diff --git a/src/main/resources/com/tikal/jenkins/plugins/multijob/views/ConsoleColumn/column.jelly b/src/main/resources/com/tikal/jenkins/plugins/multijob/views/ConsoleColumn/column.jelly
index b8b98c1..46e4a01 100644
--- a/src/main/resources/com/tikal/jenkins/plugins/multijob/views/ConsoleColumn/column.jelly
+++ b/src/main/resources/com/tikal/jenkins/plugins/multijob/views/ConsoleColumn/column.jelly
@@ -5,7 +5,7 @@
 	&lt;td data="${lBuild.duration ?: '0'}"&gt;
 		&lt;j:choose&gt;
 			&lt;j:when test="${lBuild!=null}"&gt;
-				&lt;a href="${jobBaseUrl}${lBuild.url}console"&gt;
+				&lt;a href="${rootURL}/${lBuild.url}console"&gt;
 					&lt;img src="${imagesURL}/${subIconSize}/terminal.gif" title="${%Console output}"
 						alt="${%Console output}" border="0" /&gt;
 				&lt;/a&gt;
diff --git a/src/main/resources/com/tikal/jenkins/plugins/multijob/views/JobColumn/column.jelly b/src/main/resources/com/tikal/jenkins/plugins/multijob/views/JobColumn/column.jelly
index 9ece022..76c83b1 100644
--- a/src/main/resources/com/tikal/jenkins/plugins/multijob/views/JobColumn/column.jelly
+++ b/src/main/resources/com/tikal/jenkins/plugins/multijob/views/JobColumn/column.jelly
@@ -7,8 +7,8 @@
 				${job.displayName}
 			&lt;/j:when&gt;
 			&lt;j:when test="${!job.phase}"&gt;
-				&lt;a href="${jobBaseUrl}${job.shortUrl}"&gt; ${job.displayName}&lt;/a&gt;
+				&lt;a href="${rootURL}/${job.shortUrl}"&gt; ${job.displayName}&lt;/a&gt;
 			&lt;/j:when&gt;
 		&lt;/j:choose&gt;
 	&lt;/td&gt;
-&lt;/j:jelly&gt;
\ No newline at end of file
+&lt;/j:jelly&gt;
diff --git a/src/main/resources/com/tikal/jenkins/plugins/multijob/views/WeatherColumn/column.jelly b/src/main/resources/com/tikal/jenkins/plugins/multijob/views/WeatherColumn/column.jelly
index 609cb31..ff0021b 100644
--- a/src/main/resources/com/tikal/jenkins/plugins/multijob/views/WeatherColumn/column.jelly
+++ b/src/main/resources/com/tikal/jenkins/plugins/multijob/views/WeatherColumn/column.jelly
@@ -1,5 +1,5 @@
 &lt;j:jelly xmlns:j="jelly:core" xmlns:st="jelly:stapler" xmlns:d="jelly:define"
 	xmlns:l="/lib/layout" xmlns:t="/lib/hudson" xmlns:f="/lib/form"
 	xmlns:i="jelly:fmt"&gt;
-	&lt;t:buildHealth td="true" link="${jobBaseUrl}${job.shortUrl}lastBuild" /&gt;
-&lt;/j:jelly&gt;
\ No newline at end of file
+	&lt;t:buildHealth td="true" link="${rootURL}/${job.shortUrl}lastBuild" /&gt;
+&lt;/j:jelly&gt;
-- 
1.8.0.1.244.g77b598b

</pre></body></html>