<html><head><meta name="color-scheme" content="light dark"></head><body><pre style="word-wrap: break-word; white-space: pre-wrap;">diff --git a/pom.xml b/pom.xml
index 0bcf6a9..3b0fe2e 100644
--- a/pom.xml
+++ b/pom.xml
@@ -1,158 +1,158 @@
 &lt;project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/maven-v4_0_0.xsd"&gt;
-	&lt;modelVersion&gt;4.0.0&lt;/modelVersion&gt;
-	&lt;parent&gt;
-		&lt;groupId&gt;org.jenkins-ci.plugins&lt;/groupId&gt;
-		&lt;artifactId&gt;plugin&lt;/artifactId&gt;
-		&lt;version&gt;1.451&lt;/version&gt;
-		&lt;!-- &lt;version&gt;1.460&lt;/version&gt; version caused JENKINS-13518 --&gt;
-	&lt;/parent&gt;
+    &lt;modelVersion&gt;4.0.0&lt;/modelVersion&gt;
+    &lt;parent&gt;
+        &lt;groupId&gt;org.jenkins-ci.plugins&lt;/groupId&gt;
+        &lt;artifactId&gt;plugin&lt;/artifactId&gt;
+        &lt;version&gt;1.451&lt;/version&gt;
+        &lt;!-- &lt;version&gt;1.460&lt;/version&gt; version caused JENKINS-13518 --&gt;
+    &lt;/parent&gt;
 
-	&lt;artifactId&gt;scriptler&lt;/artifactId&gt;
-	&lt;name&gt;Scriptler&lt;/name&gt;
-	&lt;version&gt;2.6-SNAPSHOT&lt;/version&gt;
-	&lt;packaging&gt;hpi&lt;/packaging&gt;
-	&lt;description&gt;Scriptler allows you to store/edit/execute groovy scripts on any of the slaves/nodes... no need to copy paste groovy code anymore. Beside administer  your scripts, Scritpler also provides a way to share scripts between users via hosted script catalogs on the internet.&lt;/description&gt;
-	&lt;url&gt;http://wiki.jenkins-ci.org/display/JENKINS/Scriptler+Plugin&lt;/url&gt;
-	&lt;inceptionYear&gt;2010&lt;/inceptionYear&gt;
-	&lt;developers&gt;
-		&lt;developer&gt;
-			&lt;id&gt;imod&lt;/id&gt;
-			&lt;name&gt;Dominik Bartholdi&lt;/name&gt;
-			&lt;email&gt;-&lt;/email&gt;
-		&lt;/developer&gt;
-	&lt;/developers&gt;
-	&lt;repositories&gt;
-		&lt;repository&gt;
-			&lt;id&gt;repo.jenkins-ci.org&lt;/id&gt;
-			&lt;url&gt;http://repo.jenkins-ci.org/public/&lt;/url&gt;
-		&lt;/repository&gt;
-	&lt;/repositories&gt;
-	&lt;pluginRepositories&gt;
-		&lt;pluginRepository&gt;
-			&lt;id&gt;repo.jenkins-ci.org&lt;/id&gt;
-			&lt;url&gt;http://repo.jenkins-ci.org/public/&lt;/url&gt;
-		&lt;/pluginRepository&gt;
-	&lt;/pluginRepositories&gt;
-	&lt;properties&gt;
-		&lt;project.build.sourceEncoding&gt;UTF-8&lt;/project.build.sourceEncoding&gt;
-	&lt;/properties&gt;
-	&lt;build&gt;
-		&lt;pluginManagement&gt;
-			&lt;plugins&gt;
-				&lt;plugin&gt;
-					&lt;groupId&gt;com.cloudbees&lt;/groupId&gt;
-					&lt;artifactId&gt;maven-license-plugin&lt;/artifactId&gt;
-					&lt;version&gt;1.7&lt;/version&gt;
-				&lt;/plugin&gt;
-				&lt;plugin&gt;
-					&lt;groupId&gt;org.kohsuke&lt;/groupId&gt;
-					&lt;artifactId&gt;access-modifier-checker&lt;/artifactId&gt;
-					&lt;version&gt;1.3&lt;/version&gt;
-				&lt;/plugin&gt;
-				&lt;plugin&gt;
-					&lt;groupId&gt;org.jvnet.localizer&lt;/groupId&gt;
-					&lt;artifactId&gt;maven-localizer-plugin&lt;/artifactId&gt;
-					&lt;version&gt;1.14&lt;/version&gt;
-				&lt;/plugin&gt;
-				&lt;!--This plugin's configuration is used to store Eclipse m2e settings only. It has no influence on the Maven build itself. --&gt;
-				&lt;plugin&gt;
-					&lt;groupId&gt;org.eclipse.m2e&lt;/groupId&gt;
-					&lt;artifactId&gt;lifecycle-mapping&lt;/artifactId&gt;
-					&lt;version&gt;1.0.0&lt;/version&gt;
-					&lt;configuration&gt;
-						&lt;lifecycleMappingMetadata&gt;
-							&lt;pluginExecutions&gt;
-								&lt;pluginExecution&gt;
-									&lt;pluginExecutionFilter&gt;
-										&lt;groupId&gt;org.apache.maven.plugins&lt;/groupId&gt;
-										&lt;artifactId&gt;maven-enforcer-plugin&lt;/artifactId&gt;
-										&lt;versionRange&gt;[1.0,)&lt;/versionRange&gt;
-										&lt;goals&gt;
-											&lt;goal&gt;display-info&lt;/goal&gt;
-										&lt;/goals&gt;
-									&lt;/pluginExecutionFilter&gt;
-									&lt;action&gt;
-										&lt;ignore /&gt;
-									&lt;/action&gt;
-								&lt;/pluginExecution&gt;
-								&lt;pluginExecution&gt;
-									&lt;pluginExecutionFilter&gt;
-										&lt;groupId&gt;org.codehaus.gmaven&lt;/groupId&gt;
-										&lt;artifactId&gt;gmaven-plugin&lt;/artifactId&gt;
-										&lt;versionRange&gt;[1.3,)&lt;/versionRange&gt;
-										&lt;goals&gt;
-											&lt;goal&gt;generateTestStubs&lt;/goal&gt;
-											&lt;goal&gt;testCompile&lt;/goal&gt;
-										&lt;/goals&gt;
-									&lt;/pluginExecutionFilter&gt;
-									&lt;action&gt;
-										&lt;ignore /&gt;
-									&lt;/action&gt;
-								&lt;/pluginExecution&gt;
-							&lt;/pluginExecutions&gt;
-						&lt;/lifecycleMappingMetadata&gt;
-					&lt;/configuration&gt;
-				&lt;/plugin&gt;
-			&lt;/plugins&gt;
-		&lt;/pluginManagement&gt;
-		&lt;plugins&gt;
-			&lt;plugin&gt;
-				&lt;groupId&gt;org.jenkins-ci.tools&lt;/groupId&gt;
-				&lt;artifactId&gt;maven-hpi-plugin&lt;/artifactId&gt;
-				&lt;version&gt;1.90&lt;/version&gt;
-				&lt;extensions&gt;true&lt;/extensions&gt;
-			&lt;/plugin&gt;
-			&lt;plugin&gt;
-				&lt;groupId&gt;org.apache.maven.plugins&lt;/groupId&gt;
-				&lt;artifactId&gt;maven-release-plugin&lt;/artifactId&gt;
-				&lt;version&gt;2.0&lt;/version&gt;
-				&lt;configuration&gt;
-					&lt;goals&gt;deploy&lt;/goals&gt;
-				&lt;/configuration&gt;
-				&lt;dependencies&gt;
-					&lt;dependency&gt;
-						&lt;groupId&gt;org.apache.maven.scm&lt;/groupId&gt;
-						&lt;artifactId&gt;maven-scm-provider-gitexe&lt;/artifactId&gt;
-						&lt;version&gt;1.3&lt;/version&gt;
-					&lt;/dependency&gt;
-				&lt;/dependencies&gt;
-			&lt;/plugin&gt;
-		&lt;/plugins&gt;
-	&lt;/build&gt;
-	&lt;scm&gt;
-		&lt;connection&gt;scm:git:git://github.com/jenkinsci/scriptler-plugin.git&lt;/connection&gt;
-		&lt;developerConnection&gt;scm:git:ssh://git@github.com/jenkinsci/scriptler-plugin.git&lt;/developerConnection&gt;
-		&lt;url&gt;https://github.com/jenkinsci/scriptler-plugin&lt;/url&gt;
-	&lt;/scm&gt;
-	&lt;distributionManagement&gt;
-		&lt;repository&gt;
-			&lt;id&gt;java.net-m2-repository&lt;/id&gt;
-			&lt;url&gt;http://maven.jenkins-ci.org:8081/content/repositories/releases/&lt;/url&gt;
-		&lt;/repository&gt;
-		&lt;snapshotRepository&gt;
-			&lt;!-- prevent accidental deployment of SNAPSHOTS to repository --&gt;
-			&lt;id&gt;local.repository&lt;/id&gt;
-			&lt;url&gt;file:/tmp/dummy-repo&lt;/url&gt;
-		&lt;/snapshotRepository&gt;
-	&lt;/distributionManagement&gt;
-	&lt;dependencies&gt;
-		&lt;dependency&gt;
-			&lt;groupId&gt;org.jenkins-ci.plugins&lt;/groupId&gt;
-			&lt;artifactId&gt;token-macro&lt;/artifactId&gt;
-			&lt;version&gt;1.5.1&lt;/version&gt;
-		&lt;/dependency&gt;
+    &lt;artifactId&gt;scriptler&lt;/artifactId&gt;
+    &lt;name&gt;Scriptler&lt;/name&gt;
+    &lt;version&gt;2.6-NOEXCEPTION-SNAPSHOT&lt;/version&gt;
+    &lt;packaging&gt;hpi&lt;/packaging&gt;
+    &lt;description&gt;Scriptler allows you to store/edit/execute groovy scripts on any of the slaves/nodes... no need to copy paste groovy code anymore. Beside administer  your scripts, Scritpler also provides a way to share scripts between users via hosted script catalogs on the internet.&lt;/description&gt;
+    &lt;url&gt;http://wiki.jenkins-ci.org/display/JENKINS/Scriptler+Plugin&lt;/url&gt;
+    &lt;inceptionYear&gt;2010&lt;/inceptionYear&gt;
+    &lt;developers&gt;
+        &lt;developer&gt;
+            &lt;id&gt;imod&lt;/id&gt;
+            &lt;name&gt;Dominik Bartholdi&lt;/name&gt;
+            &lt;email&gt;-&lt;/email&gt;
+        &lt;/developer&gt;
+    &lt;/developers&gt;
+    &lt;repositories&gt;
+        &lt;repository&gt;
+            &lt;id&gt;repo.jenkins-ci.org&lt;/id&gt;
+            &lt;url&gt;http://repo.jenkins-ci.org/public/&lt;/url&gt;
+        &lt;/repository&gt;
+    &lt;/repositories&gt;
+    &lt;pluginRepositories&gt;
+        &lt;pluginRepository&gt;
+            &lt;id&gt;repo.jenkins-ci.org&lt;/id&gt;
+            &lt;url&gt;http://repo.jenkins-ci.org/public/&lt;/url&gt;
+        &lt;/pluginRepository&gt;
+    &lt;/pluginRepositories&gt;
+    &lt;properties&gt;
+        &lt;project.build.sourceEncoding&gt;UTF-8&lt;/project.build.sourceEncoding&gt;
+    &lt;/properties&gt;
+    &lt;build&gt;
+        &lt;pluginManagement&gt;
+            &lt;plugins&gt;
+                &lt;plugin&gt;
+                    &lt;groupId&gt;com.cloudbees&lt;/groupId&gt;
+                    &lt;artifactId&gt;maven-license-plugin&lt;/artifactId&gt;
+                    &lt;version&gt;1.7&lt;/version&gt;
+                &lt;/plugin&gt;
+                &lt;plugin&gt;
+                    &lt;groupId&gt;org.kohsuke&lt;/groupId&gt;
+                    &lt;artifactId&gt;access-modifier-checker&lt;/artifactId&gt;
+                    &lt;version&gt;1.3&lt;/version&gt;
+                &lt;/plugin&gt;
+                &lt;plugin&gt;
+                    &lt;groupId&gt;org.jvnet.localizer&lt;/groupId&gt;
+                    &lt;artifactId&gt;maven-localizer-plugin&lt;/artifactId&gt;
+                    &lt;version&gt;1.14&lt;/version&gt;
+                &lt;/plugin&gt;
+                &lt;!--This plugin's configuration is used to store Eclipse m2e settings only. It has no influence on the Maven build itself. --&gt;
+                &lt;plugin&gt;
+                    &lt;groupId&gt;org.eclipse.m2e&lt;/groupId&gt;
+                    &lt;artifactId&gt;lifecycle-mapping&lt;/artifactId&gt;
+                    &lt;version&gt;1.0.0&lt;/version&gt;
+                    &lt;configuration&gt;
+                        &lt;lifecycleMappingMetadata&gt;
+                            &lt;pluginExecutions&gt;
+                                &lt;pluginExecution&gt;
+                                    &lt;pluginExecutionFilter&gt;
+                                        &lt;groupId&gt;org.apache.maven.plugins&lt;/groupId&gt;
+                                        &lt;artifactId&gt;maven-enforcer-plugin&lt;/artifactId&gt;
+                                        &lt;versionRange&gt;[1.0,)&lt;/versionRange&gt;
+                                        &lt;goals&gt;
+                                            &lt;goal&gt;display-info&lt;/goal&gt;
+                                        &lt;/goals&gt;
+                                    &lt;/pluginExecutionFilter&gt;
+                                    &lt;action&gt;
+                                        &lt;ignore /&gt;
+                                    &lt;/action&gt;
+                                &lt;/pluginExecution&gt;
+                                &lt;pluginExecution&gt;
+                                    &lt;pluginExecutionFilter&gt;
+                                        &lt;groupId&gt;org.codehaus.gmaven&lt;/groupId&gt;
+                                        &lt;artifactId&gt;gmaven-plugin&lt;/artifactId&gt;
+                                        &lt;versionRange&gt;[1.3,)&lt;/versionRange&gt;
+                                        &lt;goals&gt;
+                                            &lt;goal&gt;generateTestStubs&lt;/goal&gt;
+                                            &lt;goal&gt;testCompile&lt;/goal&gt;
+                                        &lt;/goals&gt;
+                                    &lt;/pluginExecutionFilter&gt;
+                                    &lt;action&gt;
+                                        &lt;ignore /&gt;
+                                    &lt;/action&gt;
+                                &lt;/pluginExecution&gt;
+                            &lt;/pluginExecutions&gt;
+                        &lt;/lifecycleMappingMetadata&gt;
+                    &lt;/configuration&gt;
+                &lt;/plugin&gt;
+            &lt;/plugins&gt;
+        &lt;/pluginManagement&gt;
+        &lt;plugins&gt;
+            &lt;plugin&gt;
+                &lt;groupId&gt;org.jenkins-ci.tools&lt;/groupId&gt;
+                &lt;artifactId&gt;maven-hpi-plugin&lt;/artifactId&gt;
+                &lt;version&gt;1.90&lt;/version&gt;
+                &lt;extensions&gt;true&lt;/extensions&gt;
+            &lt;/plugin&gt;
+            &lt;plugin&gt;
+                &lt;groupId&gt;org.apache.maven.plugins&lt;/groupId&gt;
+                &lt;artifactId&gt;maven-release-plugin&lt;/artifactId&gt;
+                &lt;version&gt;2.0&lt;/version&gt;
+                &lt;configuration&gt;
+                    &lt;goals&gt;deploy&lt;/goals&gt;
+                &lt;/configuration&gt;
+                &lt;dependencies&gt;
+                    &lt;dependency&gt;
+                        &lt;groupId&gt;org.apache.maven.scm&lt;/groupId&gt;
+                        &lt;artifactId&gt;maven-scm-provider-gitexe&lt;/artifactId&gt;
+                        &lt;version&gt;1.3&lt;/version&gt;
+                    &lt;/dependency&gt;
+                &lt;/dependencies&gt;
+            &lt;/plugin&gt;
+        &lt;/plugins&gt;
+    &lt;/build&gt;
+    &lt;scm&gt;
+        &lt;connection&gt;scm:git:git://github.com/jenkinsci/scriptler-plugin.git&lt;/connection&gt;
+        &lt;developerConnection&gt;scm:git:ssh://git@github.com/jenkinsci/scriptler-plugin.git&lt;/developerConnection&gt;
+        &lt;url&gt;https://github.com/jenkinsci/scriptler-plugin&lt;/url&gt;
+    &lt;/scm&gt;
+    &lt;distributionManagement&gt;
+        &lt;repository&gt;
+            &lt;id&gt;java.net-m2-repository&lt;/id&gt;
+            &lt;url&gt;http://maven.jenkins-ci.org:8081/content/repositories/releases/&lt;/url&gt;
+        &lt;/repository&gt;
+        &lt;snapshotRepository&gt;
+            &lt;!-- prevent accidental deployment of SNAPSHOTS to repository --&gt;
+            &lt;id&gt;local.repository&lt;/id&gt;
+            &lt;url&gt;file:/tmp/dummy-repo&lt;/url&gt;
+        &lt;/snapshotRepository&gt;
+    &lt;/distributionManagement&gt;
+    &lt;dependencies&gt;
+        &lt;dependency&gt;
+            &lt;groupId&gt;org.jenkins-ci.plugins&lt;/groupId&gt;
+            &lt;artifactId&gt;token-macro&lt;/artifactId&gt;
+            &lt;version&gt;1.6&lt;/version&gt;
+        &lt;/dependency&gt;
 
-		&lt;dependency&gt;
-			&lt;groupId&gt;org.jenkins-ci.modules&lt;/groupId&gt;
-			&lt;artifactId&gt;sshd&lt;/artifactId&gt;
-			&lt;version&gt;1.1&lt;/version&gt;
-			&lt;!-- &lt;scope&gt;provided&lt;/scope&gt;this is in the core --&gt;
-		&lt;/dependency&gt;
+        &lt;dependency&gt;
+            &lt;groupId&gt;org.jenkins-ci.modules&lt;/groupId&gt;
+            &lt;artifactId&gt;sshd&lt;/artifactId&gt;
+            &lt;version&gt;1.1&lt;/version&gt;
+            &lt;!-- &lt;scope&gt;provided&lt;/scope&gt;this is in the core --&gt;
+        &lt;/dependency&gt;
 
-		&lt;dependency&gt;
-			&lt;groupId&gt;org.jenkins-ci.plugins&lt;/groupId&gt;
-			&lt;artifactId&gt;git-server&lt;/artifactId&gt;
-			&lt;version&gt;1.1&lt;/version&gt;
-		&lt;/dependency&gt;
-	&lt;/dependencies&gt;
+        &lt;dependency&gt;
+            &lt;groupId&gt;org.jenkins-ci.plugins&lt;/groupId&gt;
+            &lt;artifactId&gt;git-server&lt;/artifactId&gt;
+            &lt;version&gt;1.1&lt;/version&gt;
+        &lt;/dependency&gt;
+    &lt;/dependencies&gt;
 &lt;/project&gt;
diff --git a/src/main/java/org/jenkinsci/plugins/scriptler/builder/ScriptlerBuilder.java b/src/main/java/org/jenkinsci/plugins/scriptler/builder/ScriptlerBuilder.java
index a4b19c3..ff22e36 100644
--- a/src/main/java/org/jenkinsci/plugins/scriptler/builder/ScriptlerBuilder.java
+++ b/src/main/java/org/jenkinsci/plugins/scriptler/builder/ScriptlerBuilder.java
@@ -1,5 +1,5 @@
 /**
- * 
+ *
  */
 package org.jenkinsci.plugins.scriptler.builder;
 
@@ -46,7 +46,7 @@
 
 /**
  * @author Dominik Bartholdi (imod)
- * 
+ *
  */
 public class ScriptlerBuilder extends Builder implements Serializable {
     private static final long serialVersionUID = 1L;
@@ -101,12 +101,12 @@
                         final List&lt;ParameterValue&gt; jobParams = paramsAction.getParameters();
                         for (ParameterValue parameterValue : jobParams) {
                             // pass the params to the token expander in a way that these get expanded by environment variables (params are also environment variables)
-                            expandedParams.add(new Parameter(parameterValue.getName(), TokenMacro.expandAll(build, listener, "${" + parameterValue.getName() + "}")));
+                            expandedParams.add(new Parameter(parameterValue.getName(), TokenMacro.expandAll(build, listener, "${" + parameterValue.getName() + "}", false, null)));
                         }
                     }
                 }
                 for (Parameter parameter : parameters) {
-                    expandedParams.add(new Parameter(parameter.getName(), TokenMacro.expandAll(build, listener, parameter.getValue())));
+                    expandedParams.add(new Parameter(parameter.getName(), TokenMacro.expandAll(build, listener, parameter.getValue(), false, null)));
                 }
                 final Object output;
                 if (script.onlyMaster) {
@@ -226,7 +226,7 @@
 
         /**
          * gets the argument description to be displayed on the screen when selecting a config in the dropdown
-         * 
+         *
          * @param configId
          *            the config id to get the arguments description for
          * @return the description</pre></body></html>